//---------------------------------------------------------------------------
#define NO_WIN32_LEAN_AND_MEAN
#include <shlobj.h>
#include <vcl.h>
#pragma hdrstop

#include "FolderDialog.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TFolderDialog *)
{
        new TFolderDialog(NULL);
}
//---------------------------------------------------------------------------
__fastcall TFolderDialog::TFolderDialog(TComponent* Owner)
        : TCommonDialog(Owner)
{
}
int __stdcall FolderBrowseProc(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM lpData)
{
if(!lpData)return 0;
TFolderDialog* dialog = (TFolderDialog*)lpData;
dialog->FHandle = hwnd;
if(uMsg == BFFM_SELCHANGED)
{
        char buf[MAX_PATH];
        SHGetPathFromIDList(LPITEMIDLIST(lParam),buf);
        if(dialog->FOnFolderChanged)
                dialog->OnFolderChanged(dialog, buf);
}
else
if((uMsg == BFFM_INITIALIZED)&&(dialog->FOnShow))
        dialog->OnShow(dialog);

return 0;
};
//---------------------------------------------------------------------------
bool __fastcall TFolderDialog::Execute(void)
{
BROWSEINFO bi;
setmem(&bi, sizeof(bi), 0);
bi.hwndOwner = NULL;
bi.lpszTitle = Title.c_str();
bi.lpfn = FolderBrowseProc;
bi.lParam = (long)this;

int flags = 0;
        if(FOptions.Contains(fdBrowseForComputer))
                flags|=BIF_BROWSEFORCOMPUTER;
        if(FOptions.Contains(fdBrowseForPrinter))
                flags|=BIF_BROWSEFORPRINTER;
        if(FOptions.Contains(fdDontGoBelowDomain))
                flags|=BIF_DONTGOBELOWDOMAIN;
        if(FOptions.Contains(fdReturnOnlySysAncestors))
                flags|=BIF_RETURNFSANCESTORS;
        if(FOptions.Contains(fdReturnOnlySysDirs))
                flags|=BIF_RETURNONLYFSDIRS;
        if(FOptions.Contains(fdStatusText))
                flags|=BIF_STATUSTEXT;
bi.ulFlags = flags;

if(FRoot!=NULL){
        if(FRoot.Length()>0)
                {
                LPITEMIDLIST pidl;
                LPSHELLFOLDER folder;
                SHGetDesktopFolder(&folder);
                unsigned long parsed;
                folder->ParseDisplayName(NULL,0,
                        WideString(FRoot).c_bstr(),
                        &parsed,&pidl,NULL);
                delete folder;
                bi.pidlRoot = pidl;
                };};

LPITEMIDLIST lst = SHBrowseForFolder(&bi);
FHandle = 0;
if(FOnClose)
        OnClose(this);
if(!lst)
         return false;
char buf[MAX_PATH];
SHGetPathFromIDList(lst,buf);
FFolder = buf;
return true;
}
//---------------------------------------------------------------------------
void __fastcall TFolderDialog::SetStatusText(AnsiString text)
{
if(Handle)
::SendMessage(Handle,BFFM_SETSTATUSTEXT,NULL,(long)text.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TFolderDialog::SetFolder(AnsiString folder)
{
if(Handle)
::SendMessage(Handle,BFFM_SETSELECTION,TRUE,(long)folder.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TFolderDialog::SetOkEnabled(bool enabled)
{
FOkEnabled = enabled;
enabled = (enabled)?(TRUE):(FALSE);
if(Handle)
::SendMessage(Handle,BFFM_ENABLEOK,NULL,enabled);
}
//---------------------------------------------------------------------------
namespace Folderdialog
{
        void __fastcall PACKAGE Register()
   {
         TComponentClass classes[1] = {__classid(TFolderDialog)};
         RegisterComponents("Ossam", classes, 0);

         PTypeInfo ti = *GetPropInfo(__typeinfo(TFolderDialog),"Root")->PropType;
         RegisterPropertyEditor(ti, __classid(TFolderDialog),
         "Root",__classid(TFolderPropertyEditor));
         ti = *GetPropInfo(__typeinfo(TFolderDialog),"StatusText")->PropType;
         RegisterPropertyEditor(ti, __classid(TFolderDialog),
         "StatusText",__classid(TFolderStatusPropertyEditor));

   }
}
//---------------------------------------------------------------------------

void __fastcall TFolderPropertyEditor::Edit(void)
{
BROWSEINFO bi;
setmem(&bi, sizeof(bi), 0);
bi.hwndOwner = NULL;
bi.ulFlags = 0;
bi.lpszTitle = String("Select Folder").c_str();
LPCITEMIDLIST idl = SHBrowseForFolder(&bi);
if(idl==NULL) return;

char buf[MAX_PATH];
SHGetPathFromIDList(idl,buf);

SetValue(AnsiString(buf));
};
void __fastcall TFolderStatusPropertyEditor::GetValues(Classes::TGetStrProc Proc)
{
Proc("Here you select the folder");
Proc("Now you select the folder");
Proc("Silly, didn't you get what to do?");
Proc("Alright, you need not to select a folder");
}
