//---------------------------------------------------------------------------

#ifndef FolderDialogH
#define FolderDialogH

//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <dsgnintf.hpp>
//---------------------------------------------------------------------------
class TFolderDialog;

typedef enum { fdBrowseForComputer,fdBrowseForPrinter,fdDontGoBelowDomain,
		fdReturnOnlySysAncestors,fdReturnOnlySysDirs,
		fdStatusText} TFolderDialogFlags;

typedef Set <TFolderDialogFlags,fdBrowseForComputer,fdStatusText> TFlagSet;

int __stdcall FolderBrowseProc(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM lpData);
typedef void __fastcall(__closure *TFolderChangedEvent)(TFolderDialog *Sender, AnsiString NewFolder);

class PACKAGE TFolderDialog : public TCommonDialog
{
friend int __stdcall FolderBrowseProc(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM lpData);
private:
protected:
AnsiString FFolder;
AnsiString FRoot;
AnsiString FTitle;
AnsiString FStatusText;
bool FOkEnabled;
HWND FHandle;
TFlagSet FOptions;

void __fastcall SetFolder(AnsiString folder);
void __fastcall SetOkEnabled(bool enabled);
void __fastcall SetStatusText(AnsiString text);

TNotifyEvent FOnShow;
TNotifyEvent FOnClose;
public:
        TFolderChangedEvent FOnFolderChanged;
        __fastcall TFolderDialog(TComponent* Owner);

        bool __fastcall Execute(void);

        __property HWND Handle = {read = FHandle, write = FHandle, default=NULL};
        __property AnsiString Folder = {read = FFolder, write = SetFolder};
        __property bool OkEnabled = {read = FOkEnabled, write = SetOkEnabled};

__published:
        __property TFolderChangedEvent OnFolderChanged = {read = FOnFolderChanged, write = FOnFolderChanged};
        __property TNotifyEvent OnShow = {read = FOnShow, write = FOnShow};
        __property TNotifyEvent OnClose = {read=FOnClose, write=FOnClose};

        __property AnsiString Root = {read = FRoot, write = FRoot};
        __property AnsiString StatusText = {read = FStatusText, write = SetStatusText};
        __property AnsiString Title = {read = FTitle, write = FTitle};
        __property TFlagSet Options = {read = FOptions, write = FOptions};
};

class PACKAGE TFolderPropertyEditor : public TStringProperty
{
public:
__fastcall TFolderPropertyEditor(void):Dsgnintf::TStringProperty(Designer,0){};
TPropertyAttributes __fastcall GetAttributes()
{return TPropertyAttributes()<<paDialog;};
void __fastcall Edit();

};
class PACKAGE TFolderStatusPropertyEditor : public TStringProperty
{
public:
__fastcall TFolderStatusPropertyEditor(void):Dsgnintf::TStringProperty(Designer,0){};
virtual void __fastcall GetValues(Classes::TGetStrProc Proc);
TPropertyAttributes __fastcall GetAttributes()
        {
        return TPropertyAttributes()<<paValueList;
        };
};
//---------------------------------------------------------------------------
#endif
